%global hdfsproxyversion 1.0

Name:          hadoop
Version:       0.20.2
Release:       %mkrel 1
Summary:       Hadoop Distributed File System and MapReduce implementation
Group:         Development/Java
License:       ASL 2.0
Url:           http://hadoop.apache.org/
# svn export http://svn.apache.org/repos/asf/hadoop/common/tags/release-0.20.2/ hadoop-0.20.2
# tar czf hadoop-0.20.2-src-svn.tar.gz hadoop-0.20.2
Source0:       hadoop-%{version}-src-svn.tar.gz
Source1:       http://repo1.maven.org/maven2/org/apache/hadoop/hadoop-core/%{version}/hadoop-core-%{version}.pom
Source2:       http://repo1.maven.org/maven2/org/apache/hadoop/hadoop-examples/%{version}/hadoop-examples-%{version}.pom
Source3:       http://repo1.maven.org/maven2/org/apache/hadoop/hadoop-streaming/%{version}/hadoop-streaming-%{version}.pom
#Source4:       http://repo1.maven.org/maven2/org/apache/hadoop/hadoop-test/%{version}/hadoop-test-%{version}.pom
Source4:       hadoop-test-0.20.2-modifed.pom
Source5:       http://repo1.maven.org/maven2/org/apache/hadoop/hadoop-tools/%{version}/hadoop-tools-%{version}.pom

Patch0:        hadoop-0.20.2-build_xml.patch
Patch1:        hadoop-0.20.2-build-contrib_xml.patch
Patch2:        hadoop-0.20.2-hdfsproxy-build_xml.patch
Patch3:        hadoop-0.20.2-jsp-compile-job.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils

BuildRequires: ant
BuildRequires: ivy

BuildRequires: apache-commons-beanutils
BuildRequires: apache-commons-cli
BuildRequires: apache-commons-codec
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-configuration
BuildRequires: apache-commons-daemon
# TODO BuildRequires: apache-commons-daemon-jsvc
BuildRequires: apache-commons-digester
BuildRequires: apache-commons-el
BuildRequires: apache-commons-lang
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-math
BuildRequires: apache-commons-net
BuildRequires: aspectj
BuildRequires: ecj3
BuildRequires: hsqldb
BuildRequires: jackson
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-oro
BuildRequires: javacc
BuildRequires: jdiff
BuildRequires: jetty
BuildRequires: jetty-jsp-2.1
BuildRequires: jsch
BuildRequires: junit4
BuildRequires: kfs

BuildRequires: liblog4j-java
BuildRequires: lucene2

BuildRequires: mina
BuildRequires: mina-ftpserver

BuildRequires: mockito
BuildRequires: servlet25
BuildRequires: slf4j
BuildRequires: tomcat5-jasper
BuildRequires: jets3t07
BuildRequires: xerces-j2
BuildRequires: xmlenc

Requires:      apache-commons-cli
Requires:      apache-commons-codec
Requires:      apache-commons-configuration
Requires:      apache-commons-el
Requires:      apache-commons-math
Requires:      apache-commons-net
Requires:      ecj3
Requires:      hsqldb
Requires:      jakarta-commons-httpclient
Requires:      jakarta-oro
Requires:      jets3t07
Requires:      jetty
Requires:      jetty-jsp-2.1
Requires:      kfs
Requires:      mina
Requires:      mina-ftpserver
Requires:      tomcat5-jasper
Requires:      xmlenc

Requires:      java
Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildArch:     noarch

%description
Hadoop is the distributed computing framework of Apache; hadoop-core contains the
filesystem, job tracker and map/reduce modules.


# TODO %package app
#Summary:       Hadoop Distributed File System and MapReduce implementation

#%description app
#Apache Hadoop Core is a software platform that lets one easily write
#and run applications that process vast amounts of data.

#Here's what makes Hadoop especially useful:
# - Scalable: Hadoop can reliably store and process petabytes.
# - Economical: It distributes the data and processing across clusters
#   of commonly available computers. These clusters can number into the
#   thousands of nodes.
# - Efficient: By distributing the data, Hadoop can process it in
#   parallel on the nodes where the data is located. This makes it
#   extremely rapid.
# - Reliable: Hadoop automatically maintains multiple copies of data and
#   automatically redeploys computing tasks based on failures.

#Hadoop implements MapReduce, using the Hadoop Distributed File System
#(HDFS). MapReduce divides applications into many small blocks of work.
#HDFS creates multiple replicas of data blocks for reliability, placing
#them on compute nodes around the cluster. MapReduce can then process
#the data where it is located.

%package contrib
Summary:       %{name} contributed extensions
Group:         Development/Java
Requires:      %{name} = %{version}-%{release}

%description contrib
Apache Hadoop Core is a software platform that lets one easily write
and run applications that process vast amounts of data.

This package contains %{name} contributed extensions

%package javadoc
Summary:       Javadocs for %{name}
Group:         Development/Java
Requires:      jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n hadoop-%{version}

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0


for j in $(find . -name "*.jar"); do
  mv $j $j.no
done

# TODO
#for v in $(find src/contrib/thriftfs -name "*.java"); do
#    sed -i "s|com.facebook.thrift|org.apache.thrift|" $v
#done
#src/contrib/thriftfs/src/java/org/apache/hadoop/thriftfs/HadoopThriftServer.java
rm -rf src/contrib/thriftfs/build.xml
# require 
# ftplet-api 1.0.0
# ftpserver-core 1.0.0
# ftpserver-server 1.0.0
# mina-core 2.0.0-M2-20080407.124109-12
rm src/test/org/apache/hadoop/fs/ftp/TestFTPFileSystem.java
# "empty" jar required for test
mv src/test/org/apache/hadoop/mapred/test.jar.no src/test/org/apache/hadoop/mapred/test.jar

# ant-task core tools deps
ln -sf $(build-classpath aspectjtools) lib/aspectjtools-1.6.5.jar
ln -sf $(build-classpath aspectjrt) lib/aspectjrt-1.6.5.jar
ln -sf $(build-classpath commons-beanutils) lib/commons-beanutils-1.7.0.jar
ln -sf $(build-classpath commons-beanutils-core) lib/commons-beanutils-core-1.8.0.jar
ln -sf $(build-classpath commons-cli) lib/commons-cli-1.2.jar
ln -sf $(build-classpath commons-codec) lib/commons-codec-1.4.jar
ln -sf $(build-classpath commons-collections) lib/commons-collections-3.2.1.jar
ln -sf $(build-classpath commons-configuration) lib/commons-configuration-1.6.jar
ln -sf $(build-classpath commons-daemon) lib/commons-daemon-1.0.1.jar
ln -sf $(build-classpath commons-digester) lib/commons-digester-1.8.jar
ln -sf $(build-classpath commons-el) lib/commons-el-1.0.jar
ln -sf $(build-classpath commons-httpclient) lib/commons-httpclient-3.0.1.jar
ln -sf $(build-classpath commons-lang) lib/commons-lang-2.4.jar
ln -sf $(build-classpath commons-logging) lib/commons-logging-1.1.1.jar
ln -sf $(build-classpath commons-logging-api) lib/commons-logging-api-1.0.4.jar
ln -sf $(build-classpath commons-math) lib/commons-math-2.1.jar
ln -sf $(build-classpath commons-net) lib/commons-net-1.4.1.jar
ln -sf $(build-classpath ecj3) lib/core-3.1.1.jar
ln -sf $(build-classpath jackson/jackson-core-asl) lib/jackson-core-asl-1.0.1.jar
ln -sf $(build-classpath jackson/jackson-mapper-asl) lib/jackson-mapper-asl-1.0.1.jar
ln -sf $(build-classpath jetty/jetty) lib/jetty-6.1.26.jar
ln -sf $(build-classpath jetty/jetty-util) lib/jetty-util-6.1.26.jar
ln -sf $(build-classpath jetty-jsp-2.1-api-glassfish) lib/jsp-2.1/jsp-api-2.1.jar
ln -sf $(build-classpath jetty-jsp-2.1-glassfish) lib/jsp-2.1/jsp-2.1.jar
ln -sf $(build-classpath tomcat6-servlet-api) lib/servlet-api-2.5-20081211.jar
ln -sf $(build-classpath jasper5-compiler) lib/jasper-compiler-5.5.12.jar
ln -sf $(build-classpath jasper5-runtime) lib/jasper-runtime-5.5.12.jar
ln -sf $(build-classpath oro) lib/oro-2.0.8.jar
ln -sf $(build-classpath slf4j/api) lib/slf4j-api-1.4.3.jar
ln -sf $(build-classpath slf4j/log4j12) lib/slf4j-log4j12-1.4.3.jar
ln -sf $(build-classpath hsqldb) lib/hsqldb-1.8.0.10.jar
ln -sf $(build-classpath jsch) lib/jsch-0.1.42.jar
ln -sf $(build-classpath kfs) lib/kfs-0.2.2.jar
ln -sf $(build-classpath log4j) lib/log4j-1.2.15.jar
ln -sf $(build-classpath xmlenc) lib/xmlenc-0.52.jar
ln -sf $(build-classpath junit4) lib/junit-4.5.jar
ln -sf $(build-classpath mockito-all) lib/mockito-all-1.8.5.jar
ln -sf $(build-classpath ivy) ivy/ivy-2.1.0.jar
ln -sf $(build-classpath javacc) lib/
ln -sf $(build-classpath jets3t07) lib/jets3t-0.6.1.jar
ln -sf $(build-classpath mina-ftpserver/core) lib/ftpserver-core.jar
ln -sf $(build-classpath mina-ftpserver/ftplet-api) lib/
ln -sf $(build-classpath mina/core) lib/mina-core.jar

#mkdir -p build/lib
#ln -sf $(build-classpath ant-eclipse) build/lib/ant-eclipse-1.0-jvm1.2.jar

for c in $(find . -name "*.class"); do
   rm -f $c
done

for b in $(find . -name "*.bat"); do
   rm -f $b
done

for s in $(find . -name "*.so"); do
   rm -f $s
done

for s in $(find . -name "*.so.*"); do
   rm -f $s
done

for d in $(find . -name "*.a"); do
   rm -f $d
done

for d in $(find . -name "*.la"); do
   rm -f $d
done

for d in $(find . -name "*.dll"); do
   rm -f $d
done

for d in $(find . -name "*.dll"); do
   rm -f $d
done

%build

%ant \
  -Djavadoc.link.java=%_javadocdir/java \
  -Doffline=true \
  -Divy.jar=$(build-classpath ivy) \
  -Djdiff.jar=$(build-classpath jdiff) \
  -Dxerces.jar=$(build-classpath xerces-j2) \
  -Djavacc.home=$PWD/lib \
  jar tools-jar ant-tasks examples jar-test javadoc

# TODO HOP module
#   -Dpython.home=  \

%ant \
  -f src/contrib/build.xml \
  -Djavadoc.link.java=%_javadocdir/java \
  -Dversion=%version \
  -Ddist.dir=dist \
  -Doffline=true \
  -Divy.jar=$(build-classpath ivy) \
  -Djdiff.jar=$(build-classpath jdiff) \
  -Dxerces.jar=$(build-classpath xerces-j2) \
  -Djavacc.home=$PWD/lib \
  package

export CLASSPATH=$PWD/build/hadoop-%{version}-core.jar:$PWD/build/contrib/streaming/hadoop-%{version}-streaming.jar
CLASSPATH=$CLASSPATH:$PWD/build/hadoop-%{version}-test.jar:$PWD/build/hadoop-%{version}-examples.jar
cd src/benchmarks/gridmix2
%ant main

# TODO native libs
#  (
#    cd src/c++/librecordio
#  )
#  (
#    cd src/c++/utils
#  )
#  (
#    cd src/c++/pipes
#  )
#  (
#    cd src/c++/task-controller
#  )
#  (
#    cd src/contrib/fuse-dfs
#  )
#  (
#  cd src/c++/libhdfs
#  )
  
%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}/%{name}

install -pm 644 build/%{name}-%{version}-core.jar \
  %{buildroot}%{_javadir}/%{name}/core.jar

install -pm 644 build/%{name}-%{version}-tools.jar \
  %{buildroot}%{_javadir}/%{name}/tools.jar

install -pm 644 build/%{name}-%{version}-ant.jar \
  %{buildroot}%{_javadir}/%{name}/ant.jar

install -pm 644 build/%{name}-%{version}-examples.jar \
  %{buildroot}%{_javadir}/%{name}/examples.jar

install -pm 644 build/%{name}-%{version}-test.jar \
  %{buildroot}%{_javadir}/%{name}/test.jar

install -pm 644 build/contrib/capacity-scheduler/%{name}-%{version}-capacity-scheduler.jar \
 %{buildroot}%{_javadir}/%{name}/capacity-scheduler.jar

install -pm 644 build/contrib/datajoin/%{name}-%{version}-datajoin.jar \
 %{buildroot}%{_javadir}/%{name}/datajoin.jar
install -pm 644 build/contrib/datajoin/%{name}-%{version}-datajoin-examples.jar \
 %{buildroot}%{_javadir}/%{name}/datajoin-examples.jar

install -pm 644 build/contrib/failmon/failmon.jar \
 %{buildroot}%{_javadir}/%{name}/failmon.jar

install -pm 644 build/contrib/fairscheduler/%{name}-%{version}-fairscheduler.jar \
 %{buildroot}%{_javadir}/%{name}/fairscheduler.jar

install -pm 644 src/benchmarks/gridmix2/build/gridmix.jar \
 %{buildroot}%{_javadir}/%{name}/gridmix.jar

install -pm 644 build/contrib/hdfsproxy/hdfsproxy-%{hdfsproxyversion}.jar \
 %{buildroot}%{_javadir}/%{name}/hdfsproxy.jar

install -pm 644 build/contrib/index/%{name}-%{version}-index.jar \
 %{buildroot}%{_javadir}/%{name}/index.jar

install -pm 644 build/contrib/streaming/%{name}-%{version}-streaming.jar \
 %{buildroot}%{_javadir}/%{name}/streaming.jar

install -pm 644 build/contrib/vaidya/%{name}-%{version}-vaidya.jar \
 %{buildroot}%{_javadir}/%{name}/vaidya.jar

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 %SOURCE1 %{buildroot}%{_mavenpomdir}/JPP.%{name}-core.pom
%add_to_maven_depmap org.apache.%{name} %{name}-core %{version} JPP/%{name} core
install -pm 644 %SOURCE2 %{buildroot}%{_mavenpomdir}/JPP.%{name}-examples.pom
%add_to_maven_depmap org.apache.%{name} %{name}-examples %{version} JPP/%{name} examples
install -pm 644 %SOURCE3 %{buildroot}%{_mavenpomdir}/JPP.%{name}-streaming.pom
%add_to_maven_depmap org.apache.%{name} %{name}-streaming %{version} JPP/%{name} streaming
install -pm 644 %SOURCE4 %{buildroot}%{_mavenpomdir}/JPP.%{name}-test.pom
%add_to_maven_depmap org.apache.%{name} %{name}-test %{version} JPP/%{name} test
install -pm 644 %SOURCE5 %{buildroot}%{_mavenpomdir}/JPP.%{name}-tools.pom
%add_to_maven_depmap org.apache.%{name} %{name}-tools %{version} JPP/%{name} tools

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr build/docs/api/* %{buildroot}%{_javadocdir}/%{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/%{name}/ant.jar
%{_javadir}/%{name}/core.jar
%{_javadir}/%{name}/examples.jar
%{_javadir}/%{name}/streaming.jar
%{_javadir}/%{name}/test.jar
%{_javadir}/%{name}/tools.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc CHANGES.txt LICENSE.txt NOTICE.txt README.txt

%files contrib
%{_javadir}/%{name}/capacity-scheduler.jar
%{_javadir}/%{name}/datajoin.jar
%{_javadir}/%{name}/datajoin-examples.jar
%{_javadir}/%{name}/failmon.jar
%{_javadir}/%{name}/fairscheduler.jar
%{_javadir}/%{name}/gridmix.jar
%{_javadir}/%{name}/hdfsproxy.jar
%{_javadir}/%{name}/index.jar
%{_javadir}/%{name}/vaidya.jar

%files javadoc
%{_javadocdir}/%{name}


%changelog

* Fri Oct 21 2011 gil <gil> 0.20.2-1.mga2
+ Revision: 157112
- medified test pom
- revert to 0.20.2
- imported package hadoop

